import { Promise } from "./promise";

function size(object) {
  var s = 0;

  for (var prop in object) {
    s++;
  }

  return s;
}

function hash(promises) {

  function canceller() {
    var promise,
      key;
    for (key in promises) {
      if (promises.hasOwnProperty(key)) {
        promise = promises[key];

        if (promise && typeof promise.then === 'function' &&
            typeof promise.cancel === 'function') {
          promise.cancel();
        }
      }
    }
  }

  return new Promise(function(resolve, reject) {
    var results = {}, remaining = size(promises),
      promise;

    if (remaining === 0) {
      resolve(results);
    }

    function resolver(key) {
      return function(value) {
        resolveAll(key, value);
      };
    }

    function resolveAll(key, value) {
      results[key] = value;
      if (--remaining === 0) {
        resolve(results);
      }
    }

    function cancelAll(rejectionValue) {
      reject(rejectionValue);
      canceller();
    }

    for (var prop in promises) {
      promise = promises[prop];

      if (promise && typeof promise.then === 'function') {
        promise.then(resolver(prop), cancelAll);
      } else {
        resolveAll(prop, promise);
      }
    }

  }, canceller
  );

}

export { hash };
